class mapFilter {
    string name = "";
    bool nameOn = false;
    bool[] medals = array<bool>(6, true); // unplayed, played, bronze, silver, gold, author
    bool[] difficulty = array<bool>(6, true); // white, green, blue, red, black, other
    bool old = true; // old maps witch has gotten updates

    bool lnameOn = false;
    bool[] lmedals = array<bool>(6, true); // unplayed, played, bronze, silver, gold, author
    bool[] ldifficulty = array<bool>(6, true); // white, green, blue, red, black, other
    bool lold = true; // old maps witch has gotten updates

    mapFilter() {}

    bool filterMap(mapInfo@ mi) {
        if (!medals[mi.getMedal()]) return false;
        if (!difficulty[mi.getDifficulty()]) return false;

        if (nameOn) {
            string str1 = name.ToLower(), str2 = mi.name.ToLower();
            if (!str2.Contains(str1)) return false;
        }


        return true;
    }

    bool drawFilter() {
        bool changed = false;
        name = UI::InputText("Name", name, changed);
        for (uint i = 0; i < medals.Length; i++) {
            medals[i] = UI::Checkbox(getMedalIcon(i), medals[i]);
            changed = changed || lmedals[i] != medals[i];
            lmedals[i] = medals[i];
            UI::SameLine();
        }

        UI::NewLine();

        for (uint i = 0; i < difficulty.Length; i++) {
            difficulty[i] = UI::Checkbox(getDifficultyIcon(i), difficulty[i]);
            changed = changed || ldifficulty[i] != difficulty[i];
            ldifficulty[i] = difficulty[i];
            UI::SameLine();
        }
        
        if (UI::Button(Icons::Refresh)) {
            filterMaps();
        }

        UI::SameLine();
        if (UI::Button(Icons::Times)) {
            resetFilters();
        }
        
        nameOn = name != "";

        return changed;
    }
}